global function precache_needed_stuff_like_rn
global function CreateSmallElevator
global function CreateSimpleButton
global function CreateNessy
global function CountNessy
global function HasAllNessies
global function CatPrint

void function precache_needed_stuff_like_rn()
{
    PrecacheModel( $"models/props/turret_base/turret_base.mdl" )
    PrecacheModel( $"models/signs/flag_base_pole_ctf.mdl" )
    PrecacheModel( $"models/communication/terminal_usable_imc_01.mdl" )
    PrecacheModel( $"models/domestic/nessy_doll.mdl" )

    PrecacheParticleSystem( $"P_smokescreen_FD" )
}

void function CreateSmallElevator( vector origin, vector origin2, int time )
{
    entity mover = CreateExpensiveScriptMoverModel( $"models/props/turret_base/turret_base.mdl", origin, <0,0,0>, SOLID_VPHYSICS, 5000 )
    mover.SetPusher( true )
    thread ElevatorThink( mover, origin, origin2, time )
}

void function ElevatorThink( entity mover, vector origin, vector origin2, int time  )
{
    for(;;)
    {
        mover.NonPhysicsMoveTo( origin2, time - 2, 0.1, 0.1 )
        wait time

        mover.NonPhysicsMoveTo( origin, time - 2, 0.1, 0.1 )
        wait time
    }
}

void function CreateSimpleButton( vector origin, vector angles, string text, void functionref( entity, entity ) callback, float WaitTime = 30.0 )
{
    entity button = CreateEntity( "prop_dynamic" )

    button.SetValueForModelKey( $"models/props/global_access_panel_button/global_access_panel_button_console.mdl" )
	button.kv.fadedist = 10000
	button.kv.renderamt = 255
	button.kv.rendercolor = "81 130 151"
	button.kv.solid = SOLID_VPHYSICS

    // button.kv.multiUseDelay = 30
    // button.kv.editorclass = "script_switch"

	SetTeam( button, TEAM_BOTH )
	button.SetOrigin( origin )
	button.SetAngles( angles )
	DispatchSpawn( button )

    button.SetUsable()
    button.SetUsableByGroup( "pilot" )
    button.SetUsePrompts( "Hold %use% " + text, "Press %use%" + text )
	thread ButtonThink( button, callback, WaitTime )

}

void function ButtonThink( entity button, void functionref( entity, entity ) callback, float WaitTime )
{
    while ( IsValid( button ) )
    {
        button.SetUsable()
        button.SetSkin( 0 )

        entity player = expect entity( button.WaitSignal( "OnPlayerUse" ).player )
        callback( button, player )

        button.UnsetUsable()
        EmitSoundOnEntity( button, "Switch_Activate" )
        button.SetSkin( 1 )
        wait WaitTime
    }
}

void function CreateNessy( vector origin, vector angles, int id )
{
    entity nessy = CreatePropDynamic( $"models/domestic/nessy_doll.mdl", origin, angles, SOLID_VPHYSICS, 1000 )
    thread NessyThink( nessy, id )

    nessy.SetUsable()
    nessy.SetUsableByGroup( "pilot" )
    nessy.SetUsePrompts( "Hold %use% to grab nessy", "Press %use% to grab nessy" )
}

void function NessyThink( entity nessy, int id )
{
    entity player = expect entity( nessy.WaitSignal( "OnPlayerUse" ).player )

    foreach( entity p in GetPlayerArray() )
        SendHudMessage( p, player.GetPlayerName() + " found a nessy [" + CountNessy() + " out of 6 ]", -1, 0.2, 220, 220, 220, 0, 0.15, 4, 0.15 )
    

    nessy.UnsetUsable()
    EmitSoundOnEntity( nessy, "Switch_Activate" )
    nessy.Dissolve( ENTITY_DISSOLVE_CORE, Vector( 0, 0, 0 ), 500 )

    SetNessyFound( id )
}

void function SetNessyFound( int nid )
{
    string nessies = GetConVarString("Nessy")
    string new_nessies
    for( int id = 0; id != nessies.len(); id++ )
    {
        if ( id == nid )
            new_nessies += "1"
        else
            new_nessies += format( "%c", nessies[id] )
    }

    SetConVarString( "Nessy", new_nessies )
}

int function CountNessy()
{
    string nessies = GetConVarString("Nessy")
    int nessy_count = 0
    for( int id = 0; id != nessies.len(); id++ )
    {
        if ( format( "%c", nessies[id] ) == "1" )
            nessy_count++
        
    }
    
    return nessy_count
}

bool function HasAllNessies()
{
    if ( CountNessy() >= 6 )
        return true

    return false
} 

void function CatPrint( string text )
{
    print( "------------------------" )
    print( text )
    print( "------------------------" )
}